SystemOrganization addCategory: 'JASVGI'!

Object subclass: #JASVGIObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGIObject commentStamp: '' prior: 0!
Just 
Another 
SVG
Interface!

JASVGIObject subclass: #JASVGIAttribute
	instanceVariableNames: 'attributeName attributeValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 08:03'!
fill: colorValue

	^self name: 'fill' value: colorValue! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 08:02'!
height: height

	^self name: 'height' value: height printString! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 07:54'!
name: stringName value: stringValue

	^super new initialize
		attributeName: stringName;
		attributeValue: stringValue;
		yourself! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 08:03'!
rx: rx

	^self name: 'rx' value: rx printString! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 08:03'!
ry: ry

	^self name: 'ry' value: ry printString! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 08:04'!
stroke: strokeValue

	^self name: 'stroke' value: strokeValue! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 08:02'!
width: width

	^self name: 'width' value: width printString! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 08:01'!
x: xValue

	^self name: 'x' value: xValue printString! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 08:01'!
y: yValue

	^self name: 'y' value: yValue printString! !

!JASVGIAttribute methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 08:43'!
asSvgAttribute

	^attributeName -> self getAttributeValue! !

!JASVGIAttribute methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 07:53'!
attributeName
	^attributeName! !

!JASVGIAttribute methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 07:53'!
attributeName: newValue
	attributeName := newValue! !

!JASVGIAttribute methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 07:53'!
attributeValue
	^attributeValue! !

!JASVGIAttribute methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 07:53'!
attributeValue: newValue
	attributeValue := newValue! !

!JASVGIAttribute methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 08:40'!
getAttributeValue

	(attributeValue class == String) ifFalse: [^attributeValue printString].

	^attributeValue! !

!JASVGIAttribute methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 08:18'!
isStyleAttribute

	^self class styleAttributesNames includes: attributeName! !

!JASVGIAttribute methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 10:29'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: ('(', attributeName, ' > ', self getAttributeValue,')')! !

JASVGIObject subclass: #JASVGICanvas
	instanceVariableNames: 'xmlCanvas svgTag svgObjects svgMarkers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

JASVGICanvas subclass: #JASVGIBpmCanvas
	instanceVariableNames: 'namesAndTags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGIBpmCanvas methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 10:21'!
defaultTaskFillColor

	^'lightsteelblue'! !

!JASVGIBpmCanvas methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 10:21'!
defaultTaskHeight

	^80! !

!JASVGIBpmCanvas methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 10:21'!
defaultTaskStroke

	^'darkblue'! !

!JASVGIBpmCanvas methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 10:21'!
defaultTaskWidth

	^120! !

!JASVGIBpmCanvas methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 13:20'!
drawActivityNamed: aString at: aPoint
	| rectId textPoint |

	rectId := self drawRoundRectangleAt: aPoint 
						height: self defaultTaskHeight 
						width: self defaultTaskWidth 
						fillColor: self defaultTaskFillColor 
						stroke: self defaultTaskStroke.

	textPoint := (aPoint x + (self defaultTaskWidth // 3)) @ (aPoint y + (self defaultTaskHeight // 2)).

	self drawText: aString at: textPoint.

	namesAndTags at: aString put: rectId! !

!JASVGIBpmCanvas methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 10:26'!
getJasvgiTagNamed: aString

	^self getJasvgiTagNamed: aString ifAbsent: [nil]! !

!JASVGIBpmCanvas methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 10:26'!
getJasvgiTagNamed: aString ifAbsent: aBlock

	^svgObjects 
			at: (namesAndTags at: aString ifAbsent: [^aBlock value]) 
			ifAbsent: aBlock! !

!JASVGIBpmCanvas methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 10:21'!
initialize

	super initialize.

	namesAndTags := Dictionary new.! !

!JASVGIBpmCanvas methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 10:21'!
namesAndTags
	^namesAndTags! !

!JASVGIBpmCanvas methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 10:21'!
namesAndTags: newValue
	namesAndTags := newValue! !

!JASVGICanvas methodsFor: 'draw' stamp: 'BrunoBB 09/06/2016 13:59'!
contents
	
	svgTag with: [
		(svgObjects orderedKeys select: [:e | e notNil]) do:[:key | | svgFigureTag figureName |
			svgFigureTag := svgObjects at: key.
			figureName := (key subStrings: '.') first.
			svgFigureTag drawOn: self.
			svgFigureTag hasValue
			ifTrue: [xmlCanvas tag: figureName attributes: svgFigureTag asSvgAttributes with: svgFigureTag value] 
			ifFalse: [xmlCanvas tag: figureName attributes: svgFigureTag asSvgAttributes].
		].
	].

	^xmlCanvas contents! !

!JASVGICanvas methodsFor: 'draw' stamp: 'BrunoBB 09/06/2016 13:17'!
draw: aJASVGITagFigure

	^svgObjects at: aJASVGITagFigure getGlobalId put: aJASVGITagFigure! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/06/2016 11:11'!
drawRectangleAt: aPoint height: height width: width fillColor: fillColor stroke: stroke

	^self drawRectangleAt: aPoint id: UUID new asString height: height width: width fillColor: fillColor stroke: stroke! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/06/2016 13:18'!
drawRectangleAt: aPoint id: id height: height width: width fillColor: fillColor stroke: stroke
	| attributes svgFigureTag |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute name: 'x' value: aPoint x);
		add: (JASVGIAttribute name: 'y' value: aPoint y);
		add: (JASVGIAttribute name: 'fill' value: fillColor);
		add: (JASVGIAttribute name: 'height' value: height);
		add: (JASVGIAttribute name: 'width' value: width);
		add: (JASVGIAttribute name: 'stroke' value: stroke);
		yourself.

	svgFigureTag := JASVGITagFigure id: id name: 'rect' withAll: attributes.

	^self draw: svgFigureTag! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/06/2016 11:11'!
drawRoundRectangleAt: aPoint height: height width: width fillColor: fillColor stroke: stroke

	^self drawRoundRectangleAt: aPoint id: UUID new asString height: height width: width fillColor: fillColor stroke: stroke! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/06/2016 13:18'!
drawRoundRectangleAt: aPoint id: id height: height width: width fillColor: fillColor stroke: stroke
	| attributes svgFigureTag |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute name: 'x' value: aPoint x);
		add: (JASVGIAttribute name: 'y' value: aPoint y);
		add: (JASVGIAttribute name: 'rx' value: 10);
		add: (JASVGIAttribute name: 'ry' value: 10);
		add: (JASVGIAttribute name: 'fill' value: fillColor);
		add: (JASVGIAttribute name: 'height' value: height);
		add: (JASVGIAttribute name: 'width' value: width);
		add: (JASVGIAttribute name: 'stroke' value: stroke);
		yourself.

	svgFigureTag := JASVGITagFigure id: id name: 'rect' withAll: attributes.

	^self draw: svgFigureTag! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/06/2016 11:11'!
drawText: aString at: aPoint 

	^self drawText: aString at: aPoint id: UUID new asString! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/06/2016 13:18'!
drawText: aString at: aPoint id: id 
	| attributes svgFigureTag |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute name: 'x' value: aPoint x);
		add: (JASVGIAttribute name: 'y' value: aPoint y);
		yourself.

	svgFigureTag := JASVGITagFigure id: id name: 'text' withAll: attributes.
	svgFigureTag value: aString.

	^self draw: svgFigureTag! !

!JASVGICanvas methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 11:12'!
initialize
	| header |

	super initialize.

	xmlCanvas := XMLWriter new.
	svgObjects := OrderPreservingDictionary new.
	svgMarkers := OrderPreservingDictionary new.

	header := OrderedCollection new 
							add: ('xmlns' -> 'http://www.w3.org/2000/svg');
							add: ('xmlns:xlink' -> 'http://www.w3.org/1999/xlink');
							yourself.

	svgTag := xmlCanvas tag: 'svg' attributes: header.! !

!JASVGICanvas methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 11:12'!
svgMarkers
	^svgMarkers! !

!JASVGICanvas methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 11:12'!
svgMarkers: newValue
	svgMarkers := newValue! !

!JASVGICanvas methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 11:11'!
svgObjects
	^svgObjects! !

!JASVGICanvas methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 11:11'!
svgObjects: newValue
	svgObjects := newValue! !

!JASVGICanvas methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 11:11'!
svgTag
	^svgTag! !

!JASVGICanvas methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 11:11'!
svgTag: newValue
	svgTag := newValue! !

!JASVGICanvas methodsFor: 'draw' stamp: 'BrunoBB 09/06/2016 14:02'!
tag: tagName attributes: aCollection

	^xmlCanvas tag: tagName attributes: aCollection! !

!JASVGICanvas methodsFor: 'draw' stamp: 'BrunoBB 09/06/2016 14:02'!
tag: tagName attributes: aCollection with: textOrBlock

	^xmlCanvas tag: tagName attributes: aCollection with: textOrBlock! !

!JASVGICanvas methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 11:11'!
xmlCanvas
	^xmlCanvas! !

!JASVGICanvas methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 11:11'!
xmlCanvas: newValue
	xmlCanvas := newValue! !

!JASVGIObject class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 07:28'!
new

	^super new initialize! !

!JASVGIObject class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 09:20'!
styleAttributesNames

	^#('fill' 'stroke' 'stroke-width')! !

JASVGIObject subclass: #JASVGITagElement
	instanceVariableNames: 'id tagName attributes subTags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 11:03'!
add: aJASVGIAttribute

	^attributes add: aJASVGIAttribute! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 11:03'!
addAll: aCollection

	^attributes addAll: aCollection! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 11:03'!
addSubTag: aJASVGITag

	^subTags at: aJASVGITag id put: aJASVGITag! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 11:08'!
asSvgAttributes
	| svgAttributes styles |

	svgAttributes := OrderedCollection new.
	styles := PrintStream on: String new.

	attributes do: [:each | 
		each isStyleAttribute
		ifTrue: [styles nextPutAll: (each attributeName, ': ', each attributeValue,';')] 
		ifFalse: [svgAttributes add: each asSvgAttribute]].

	svgAttributes 
		add: ('id' -> id);
		add: ('style' -> styles contents).

	^svgAttributes! !

!JASVGITagElement methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 11:03'!
attributes
	^attributes! !

!JASVGITagElement methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 11:03'!
attributes: newValue
	attributes := newValue! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 14:00'!
drawOn: aJASVGICanvas

	aJASVGICanvas tag: self tagName attributes: self asSvgAttributes! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 13:18'!
getGlobalId

	^self tagName, '.', self id! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 11:03'!
hasSubTags

	^subTags notEmpty! !

!JASVGITagElement methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 11:07'!
id
	^id! !

!JASVGITagElement methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 11:07'!
id: newValue
	id := newValue! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 11:06'!
initialize

	super initialize.

	attributes := OrderedCollection new.
	subTags := Dictionary new.! !

!JASVGITagElement methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 11:03'!
subTags
	^subTags! !

!JASVGITagElement methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 11:03'!
subTags: newValue
	subTags := newValue! !

!JASVGITagElement methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 11:03'!
tagName
	^tagName! !

!JASVGITagElement methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 11:03'!
tagName: newValue
	tagName := newValue! !

JASVGITagElement subclass: #JASVGITagFigure
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagFigure class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 11:04'!
id: id name: aString withAll: anOrderedCollection

	^super new initialize
		id: id;
		tagName: aString;
		attributes: anOrderedCollection;
		yourself! !

!JASVGITagFigure class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 11:04'!
id: id withAll: anOrderedCollection

	^super new initialize
		id: id;
		attributes: anOrderedCollection;
		yourself! !

!JASVGITagFigure class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 11:04'!
name: aString withAll: anOrderedCollection

	^super new initialize
		tagName: aString;
		attributes: anOrderedCollection;
		yourself! !

!JASVGITagFigure class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 11:04'!
withAll: anOrderedCollection

	^super new initialize
		attributes: anOrderedCollection;
		yourself! !

!JASVGITagFigure methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 11:03'!
hasValue

	^value notNil! !

!JASVGITagFigure methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 11:02'!
value
	^value! !

!JASVGITagFigure methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 11:02'!
value: newValue
	value := newValue! !

JASVGITagElement subclass: #JASVGITagMarker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

JASVGITagElement subclass: #JASVGITagPath
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

JASVGITagElement subclass: #JASVGITagText
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagText methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 14:00'!
drawOn: aJASVGICanvas

	aJASVGICanvas tag: self tagName attributes: self asSvgAttributes with: text! !

!JASVGITagText methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 13:53'!
text
	^text! !

!JASVGITagText methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 13:53'!
text: newValue
	text := newValue! !
